<style scoped>

    table td {
        text-align: center;
        vertical-align: middle;
    }

</style>

<template src="./createProductsComponent.htm"></template>

<script>

    import Vue from 'vue';
    import AutocompleteComponent from '../../../../../inputs/AutocompleteComponent.vue';
    import ValidationErrorsMixin from '../../../../../mixins/validationErrorsMixin.js';

    Vue.component('autocomplete-input', AutocompleteComponent);

    export default {

        mounted() {

            eventBus.$on('order-status-changed', (status) => this.orderStatusChanged(status));
        },

        data() {

            return {
                
                orderStatus: 1,

                autocompleteKey: 0,

                products: []
            }
        },

        mixins: [ ValidationErrorsMixin ],

        methods: {

            /**
             * Reset data if status is changed, because of fresh backend data.
             */
            orderStatusChanged(status) {

                this.orderStatus = status;

                this.products = [];
            },


            /**
             * When select product from auto-complete, push to products array.
             *
             * @param product
             */
            pushToProducts(product) {

                this.$refs['products'].setErrors([]);

                this.autocompleteKey++;

                this.products.push({

                    id: product.id,

                    name: product.name,

                    variants: product.variants,

                    image: product.main_image.src,

                    product_variant_id: null,

                    quantity: 1,

                    price: 0,

                    basePrice: 0,

                    warehouses: [],

                    warehouseId: null,

                    attributesValues: product.attributes.map( (el) => {

                        return {

                            attributeId: el.id,

                            attributeName: el.name,

                            values: el.values,

                            valueId: null
                        }
                    })
                });
            },


            /**
             * When selecting attribute values, find product variant.
             *
             * @param index
             */
            findProductVariant(index) {

                this.products[index].warehouseId    = null;
                this.products[index].warehouses     = [];
                let variants                        = this.products[index].variants;
                let attributesValues                = this.products[index].attributesValues;

                let variant = variants.find( (variant) => {

                     return variant.product_attribute_values.length ===

                         variant.product_attribute_values.filter( (pav) => {

                             return attributesValues.find( (av) => {

                                 return av.attributeId == pav.attribute_id && av.valueId == pav.attribute_value_id;
                             });

                         }).length;
                });

                if (variant) {

                    this.updateProductOnFoundVariant(variant, index);
                }
            },


            /**
             * Helper function to update product in products array with given product variant.
             *
             * @param variant
             * @param index
             */
            updateProductOnFoundVariant(variant, index) {

                this.products[index].product_variant_id = variant.id;
                this.products[index].price              = variant.price * this.products[index].quantity;
                this.products[index].basePrice          = variant.price;
                this.products[index].warehouses         = variant.warehouse_inventories.map( (el) => {

                    return {

                        id: el.warehouse.id,
                        name: el.warehouse.name,
                        max: el.quantity
                    }
                });
            },


            /**
             * Remove from products array.
             *
             * @index
             */
            removeProduct(index) {

                this.products.splice(index, 1);
            },


            /**
             * Get small cached product image.
             *
             * @param src
             * @return {*}
             */
            getProductImage(src) {

                return route('images.cache', { template: 'small', filename: src });
            },


            /**
             * Create order products in store.
             *
             * @param products
             */
            createOrderProductsStoreObject(products) {

                return products.map( (el) => {

                    return {

                        product_variant_id: el.product_variant_id,
                        quantity: el.quantity,
                        warehouse_id: el.warehouseId,
                        price: el.price
                    }
                });
            },


            /**
             * Increase product price by quantity.
             *
             * @param index
             */
            increasePriceByQuantity(index) {

                this.products[index].price = this.products[index].basePrice * this.products[index].quantity;
            }
        },

        computed: {

            /**
             * Whenever order status is changed update it in auto-complete component.
             *
             * @return {{status: (number|*)}}
             */
            queryStatus() {

                return {

                    status: this.orderStatus
                }
            },

            /**
             * Whenever quantity of selected product variant is changed,
             * update available warehouses for selected quantity.
             */
            availableWarehouses() {

                return (index) => this.products[index].warehouses.filter((el) => {

                    return el.max >= this.products[index].quantity;
                });
            }
        },

        watch: {

            /**
             * With each products change update in store.
             */
            products: {

                handler(newProducts) {

                    this.$store.dispatch('setOrderProducts', this.createOrderProductsStoreObject(newProducts));
                },

                deep: true
            }
        }
    }

</script>